ChallengerHeckhydraulik = {};

function ChallengerHeckhydraulik.prerequisitesPresent(specializations)
    return true;
end;

function ChallengerHeckhydraulik:load(xmlFile)
	
	self.brake = SpecializationUtil.callSpecializationsFunction("brake");
    self.releaseBrake = SpecializationUtil.callSpecializationsFunction("releaseBrake");

	self.worklightBack = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.worklightBack#front"));
	setVisibility(self.worklightBack, false);
	self.worklightBack2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.worklightBack#back"));
	self.lightSource = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.worklightBack#lightSource"));
	setVisibility(self.worklightBack2, false);
	self.worklightFront = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.worklightFront#index"));
	setVisibility(self.worklightFront, false);
	self.farLight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.farLight#front"));
	setVisibility(self.farLight, false);
	self.farLight2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.farLight#back"));
	setVisibility(self.farLight2, false);
	self.farLight3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.farLight#left"));
	setVisibility(self.farLight3, false);
	self.farLight4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.farLight#right"));
	setVisibility(self.farLight4, false);
	self.brakeLight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.brakeLight#index"));
	setVisibility(self.brakeLight, false);
	
	self.twinWheels = {};
	self.twinWheels[1] = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.twinWheels#wheel1"));
	self.twinWheels[2] = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.twinWheels#wheel2"));
	self.twinWheels[3] = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.twinWheels#wheel3"));
	self.twinWheels[4] = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.twinWheels#wheel4"));
	for i=1, table.getn(self.twinWheels) do
		setVisibility(self.twinWheels[i], false);
	end;
	
	self.posiLightRight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.posiLights#left"));
	self.posiLightLeft = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.posiLights#right"));
	self.motorBrakeForce = self.motor.brakeForce;
	self.fuelUsaged = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.fuelUsaged"), 0.01);
	
	local brakeSound = getXMLString(xmlFile, "vehicle.brakeSound#file");
    if brakeSound ~= nil and brakeSound ~= "" then
        brakeSound = Utils.getFilename(brakeSound, self.baseDirectory);
        self.brakeSound = createSample("brakeSound");
        loadSample(self.brakeSound, brakeSound, false);
        self.brakeSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.brakeSound#pitchOffset"), 0);
    end;
	self.brakeForce = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.brakeForce"), 10);
	self.full = false;
	local compresseAirSound = getXMLString(xmlFile, "vehicle.compresseAirSound#file");
    if compresseAirSound ~= nil and compresseAirSound ~= "" then
        compresseAirSound = Utils.getFilename(compresseAirSound, self.baseDirectory);
        self.compresseAirSound = createSample("compresseAirSound");
        self.compresseAirSoundEnabled = false;
        loadSample(self.compresseAirSound, compresseAirSound, false);
        self.compresseAirSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.compresseAirSound#pitchOffset"), 1);
        self.compresseAirSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.compresseAirSound#volume"), 1);
    end;
	
	self.wheelParticleSystems = {};
    local psFile = getXMLString(xmlFile, "vehicle.wheelParticleSystems#file");
    if psFile ~= nil then
        local i=0;
        while true do
            local baseName = string.format("vehicle.wheelParticleSystems.wheelParticleSystem(%d)", i);
            local node = getXMLString(xmlFile, baseName.. "#node");
            if node == nil then
                break;
            end;
            node = Utils.indexToObject(self.components, node);
			self.wheelParticleSystems.node = node;
            if node ~= nil then
                local wheelParticleSystem = {};
                wheelParticleSystem.particleSystems = {};
                Utils.loadParticleSystem(xmlFile, wheelParticleSystem.particleSystems, "vehicle.wheelParticleSystems", node, false, nil, self.baseDirectory);
                table.insert(self.wheelParticleSystems, wheelParticleSystem);
            end;
            i = i+1;
        end;
    end;
	
	self.twinWheelParticleSystems = {};
    local psFile = getXMLString(xmlFile, "vehicle.twinWheelParticleSystems#file");
    if psFile ~= nil then
        local i=0;
        while true do
            local baseName = string.format("vehicle.twinWheelParticleSystems.twinWheelParticleSystem(%d)", i);
            local node = getXMLString(xmlFile, baseName.. "#node");
            if node == nil then
                break;
            end;
            node = Utils.indexToObject(self.components, node);
			self.twinWheelParticleSystems.node = node;
            if node ~= nil then
                local twinWheelParticleSystem = {};
                twinWheelParticleSystem.particleSystems = {};
                Utils.loadParticleSystem(xmlFile, twinWheelParticleSystem.particleSystems, "vehicle.twinWheelParticleSystems", node, false, nil, self.baseDirectory);
                table.insert(self.twinWheelParticleSystems, twinWheelParticleSystem);
            end;
            i = i+1;
        end;
    end;
	
	self.backCoupling = {};
	self.backCoupling.rotationNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.backCoupling#rotationNode"));
	self.backCoupling.rotationNode2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.backCoupling#rotationNode2"));
	self.backCoupling.topArmNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.backCoupling#topArmNode"));
	
	self.wheelMode = true;
	self.lightCount = 0;
	self.catHandbrake = true;
	self.brakeOn = false;
	self.oilPressure = 1;
	self.brakePressure = 7;
	self.terminalCode = 0;
	self.terminalCodeTime = 0;
	self.showTime = 20000;
	self.rearAttacher = false;
	self.rearAttacherJoint = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rearAttacher#index"));
	self.terminalPic = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.terminalCode#index"));
	setVisibility(self.terminalPic, false);
	self.isKinkSteering = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.isKinkSteering#value"), false);
	self.backUpMaxRpm = self.motor.maxRpm[3];
	self.helpPanelPath = Utils.getFilename("CatSubHud.png", self.baseDirectory);
	self.HudWidth = 0.386;
	self.HudHeight = 0.252; --old 0.256;
	self.HudPosX = 0.002;
	self.HudPosY = 0.001;
	self.helpPanelTextPosX = 0.003;
	self.helpPanelTextPosY = 0.356;
	self.helpPanelOverlay = Overlay:new("Helppanel", self.helpPanelPath, self.HudPosX, self.HudPoxY, self.HudWidth, self.HudHeight);
	self.helpPanelActive = false;
	
end;

function ChallengerHeckhydraulik:delete()
	for i=1, table.getn(self.wheelParticleSystems) do
		Utils.deleteParticleSystem(self.wheelParticleSystems[i].particleSystems);
    end;
	for i=1, table.getn(self.twinWheelParticleSystems) do
		Utils.deleteParticleSystem(self.twinWheelParticleSystems[i].particleSystems);
    end;
	if self.compresseAirSound ~= nil then
        delete(self.compressedAirSound);
    end;
end;

function ChallengerHeckhydraulik:mouseEvent(posX, posY, isDown, isUp, button)
end;

function ChallengerHeckhydraulik:keyEvent(unicode, sym, modifier, isDown)
end;

function ChallengerHeckhydraulik:update(dt)
	if self:getIsActiveForInput() then
		self.aiTurnNoBackward = true;
		if InputBinding.hasEvent(InputBinding.HELPPANELCAT) then
			self.helpPanelActive = not self.helpPanelActive;
		end;
		self.input = InputBinding.getAnalogInputAxis(InputBinding.AXIS_FORWARD);
		if InputBinding.isAxisZero(self.input) then
			self.input = InputBinding.getDigitalInputAxis(InputBinding.AXIS_FORWARD);
		end;
		local brake = false;
		if self.motor.brakeForce == self.brakeForce and self.input ~= 0 and not self.catHandbrake then
			brake = true;
			self.motor.maxRpm[3] = 0;
			self.ESLimiter.maxRPM[3] = 0;
		end;
		if (self.movingDirection*self.lastSpeed*self.input) > 0.0007 then
			brake = true;
			self.brakeOn = true;
		    self.motor.brakeForce = self.brakeForce;
		elseif not brake then
			if self.catHandbrake then
				self.motor.brakeForce = self.brakeForce;
				self.motor.maxRpm[3] = 0;
				self.motor.speedLevel = 0;
				self.ESLimiter.maxRPM[3] = 0;
				self:stopAITractor();
			else
				if self.motor.maxRpm[3] == 0 then
					self.motor.maxRpm[3] = self.backUpMaxRpm;
				end;
				if self.ESLimiter.maxRPM[3] == 0 then
					self.ESLimiter.maxRPM[3] = self.backUpMaxRpm;
				end;
				self.motor.brakeForce = self.motorBrakeForce;
			end;
		end;
		if brake then
			self:brake();
        else
			self:releaseBrake();
        end;
		if self.brakeOn and not brake then
			for k, implement in pairs(self.attachedImplements) do
				if implement.object:onBrake() then
					self.brakePressure = self.brakePressure-(0.28*k);
				end;
			end;
			self.brakePressure = self.brakePressure-0.11;
			if self.brakeSound ~= nil then
				setSamplePitch(self.brakeSound, self.brakeSoundPitchOffset);
				playSample(self.brakeSound, 1, 1.5, 0);
			end;
			self.brakeOn = false;
		end;
		if self.brakePressure <= 6 then
			self.motor.brakeForce = self.brakeForce;
			self.motor.maxRpm[3] = 0;
			self.motor.speedLevel = 0;
			self:stopAITractor();
		end;
		if InputBinding.hasEvent(InputBinding.REARATTACHER) then
			self.rearAttacher = not self.rearAttacher;
		end;
		if self.rearAttacher then
			if table.getn(self.attachedImplements) > 0 then
				local x, y, z = getRotation(self.wheels[5].repr);
				setRotation(self.rearAttacherJoint, 0, y*0.5, 0);
			else
				setRotation(self.rearAttacherJoint, 0, 0, 0);
			end;
		else
			setRotation(self.rearAttacherJoint, 0, 0, 0);
		end;
		if InputBinding.hasEvent(InputBinding.TOGGLE_LIGHTS) then
			if not Input.isKeyPressed(Input.KEY_shift) then
				self.lightCount =  self.lightCount+1;
			else
				self.lightCount =  self.lightCount-1;
			end;
		end;
		if self.lightCount <= 0 then
			self.lightCount = 0;
		end;
		if self.lightCount == 0 then
			setVisibility(self.worklightBack, false);
			setVisibility(self.worklightBack2, false);
			setVisibility(self.worklightFront, false);
			setVisibility(self.farLight, false);
			setVisibility(self.farLight2, false);
			setVisibility(self.farLight3, false);
			setVisibility(self.farLight4, false);
		elseif self.lightCount == 1 then
			setVisibility(self.worklightBack, false);
			setVisibility(self.worklightBack2, false);
			setVisibility(self.worklightFront, false);
			setVisibility(self.farLight, true);
			setVisibility(self.farLight2, true);
			setVisibility(self.farLight3, true);
			setVisibility(self.farLight4, true);
		elseif self.lightCount == 2 then
			setVisibility(self.worklightBack, false);
			setVisibility(self.worklightBack2, false);
			setVisibility(self.worklightFront, true);
			setVisibility(self.farLight, true);
			setVisibility(self.farLight2, true);
			setVisibility(self.farLight3, true);
			setVisibility(self.farLight4, true);
		elseif self.lightCount == 3 then
			setVisibility(self.worklightBack, true);
			setVisibility(self.worklightBack2, true);
			setVisibility(self.worklightFront, false);
			setVisibility(self.farLight, true);
			setVisibility(self.farLight2, true);
			setVisibility(self.farLight3, true);
			setVisibility(self.farLight4, true);
		elseif self.lightCount == 4 then
			setVisibility(self.worklightBack, false);
			setVisibility(self.worklightBack2, false);
			setVisibility(self.worklightFront, true);
			setVisibility(self.farLight, false);
			setVisibility(self.farLight2, false);
			setVisibility(self.farLight3, false);
			setVisibility(self.farLight4, false);
		elseif self.lightCount == 5 then
			setVisibility(self.worklightBack, true);
			setVisibility(self.worklightBack2, true);
			setVisibility(self.worklightFront, true);
			setVisibility(self.farLight, false);
			setVisibility(self.farLight2, false);
			setVisibility(self.farLight3, false);
			setVisibility(self.farLight4, false);
		elseif self.lightCount == 6 then
			setVisibility(self.worklightBack, true);
			setVisibility(self.worklightBack2, true);
			setVisibility(self.worklightFront, false);
			setVisibility(self.farLight, false);
			setVisibility(self.farLight2, false);
			setVisibility(self.farLight3, false);
			setVisibility(self.farLight4, false);
		elseif self.lightCount >= 7 then
			self.lightCount = 0;
		end;
		if self.lightCount ~= 0 then
			self:setLightsVisibility(true);
		end;
		local x, y, z = getRotation(self.wheels[5].repr);
		setRotation(self.lightSource, x, (y/2)*-1, z);
		if self.steeringEnabled and self.isMotorStarted then
			local fuelUsed = (self.motor.lastMotorRpm/self.backUpMaxRpm)*self.fuelUsaged;
            self:setFuelFillLevel(self.fuelFillLevel-fuelUsed);
            g_currentMission.missionStats.fuelUsageTotal = g_currentMission.missionStats.fuelUsageTotal + fuelUsed;
            g_currentMission.missionStats.fuelUsageSession = g_currentMission.missionStats.fuelUsageSession + fuelUsed;
		end;
		if InputBinding.hasEvent(InputBinding.CATWHEELMODE) then
			self.wheelMode = not self.wheelMode;
		end;
		if InputBinding.hasEvent(InputBinding.CATHANDBRAKE) then
			if self.catHandbrake then
				if self.brakeSound ~= nil and self.brakePressure > 0 then
					setSamplePitch(self.brakeSound, self.brakeSoundPitchOffset);
					playSample(self.brakeSound, 1, 1.5, 0);
				end;
				self.brakePressure = self.brakePressure-0.35;
			else
				self.brakePressure = self.brakePressure-0.18;
			end;
			self.catHandbrake = not self.catHandbrake;
		end;
		local x1, y1, z1 = getTranslation(self.posiLightRight);
		local x2, y2, z2 = getTranslation(self.posiLightLeft);
		local trans1 = {x1,y1,z1};
		local trans2 = {x2,y2,z2};
		local newTrans1 = Utils.getMovedLimitedValues(trans1, {1.4223,y1,z1}, {0.5485,y1,z1}, 3, 800, dt, self.wheelMode);
		local newTrans2 = Utils.getMovedLimitedValues(trans2, {-1.4223,y1,z1}, {-0.5485,y1,z1}, 3, 800, dt, self.wheelMode);
		setTranslation(self.posiLightRight, unpack(newTrans1));
		setTranslation(self.posiLightLeft, unpack(newTrans2));
		if self.wheelMode then
			for i=1, table.getn(self.twinWheels) do
				setVisibility(self.twinWheels[i], false);
			end;
		else
			for i=1, table.getn(self.twinWheels) do
				setVisibility(self.twinWheels[i], true);
			end;
		end;
	end;
	if Input.isKeyPressed(Input.KEY_f5) and self.terminalCode == 0 then
		self.terminalCode = 5;
	elseif Input.isKeyPressed(Input.KEY_f5) and self.terminalCode == 5 then
		self.terminalCode = 10;
	elseif Input.isKeyPressed(Input.KEY_f3) and self.terminalCode == 10 then
		self.terminalCode = 13;
	elseif Input.isKeyPressed(Input.KEY_f1) and self.terminalCode == 13 then
		self.terminalCodeTime = self.terminalCodeTime+dt;
	else
		self.showTime = self.showTime-dt;
	end;
	if self.terminalCodeTime > 2000 then
		setVisibility(self.terminalPic, true);
		self.terminalCode = 0;
	end;
	if self.showTime < 0 then
		setVisibility(self.terminalPic, false);
		self.showTime = 20000;
		self.terminalCodeTime =0;
	end;
	if self.isMotorStarted then
		local oilPressure = 0;
		if not self.playMotorSound then
			if self.brakePressure < 9.6 and not self.full then
				self.full = true;
			elseif self.brakePressure > 10.8 and self.full then
				self.full = false;
				if self.compresseAirSound ~= nil then
					playSample(self.compresseAirSound, 1, self.compresseAirSoundVolume, 0);
                    setSamplePitch(self.compresseAirSound, self.compresseAirSoundPitchOffset);
				end;
			end;
			if self.full then
				self.brakePressure = self.brakePressure+0.0035;
			else
				self.brakePressure = self.brakePressure-0.00026;
			end;
			oilPressure = math.max(((self.motor.lastMotorRpm/self.backUpMaxRpm)*4.5), 1.1);
			if self.oilPressure > oilPressure then
				self.oilPressure = self.oilPressure - 0.0583;
			elseif self.oilPressure < oilPressure then
				self.oilPressure = self.oilPressure + 0.0583;
			end;
		end;
	else
		self.terminalCode = 0;
		self.oilPressure = 0;
		setVisibility(self.terminalPic, false);
		self.brakePressure = self.brakePressure-0.00006;
	end;
	if self.brakePressure <= 0 then
		self.brakePressure = 0;
	end;
	local dens = 0; local dens1; local dens2; local dens3;
	local x,y,z = getWorldTranslation(self.wheels[2].repr);
	local x1,y1,z1 = getWorldTranslation(self.wheels[1].repr);
	local x2,y2,z2 = getWorldTranslation(self.wheels[4].repr);
	local id = g_currentMission.terrainDetailId;
	local xx, zz, widthX, widthZ, heightX, heightZ = Utils.getXZWidthAndHeight(id, x, z, x1, z1, x2, z2);
	dens1 = getDensityParallelogram(id, xx, zz, widthX, widthZ, heightX, heightZ, g_currentMission.cultivatorChannel, 1);
	dens2 = getDensityParallelogram(id, xx, zz, widthX, widthZ, heightX, heightZ, g_currentMission.sowingChannel, 1);
	dens3 = getDensityParallelogram(id, xx, zz, widthX, widthZ, heightX, heightZ, g_currentMission.ploughChannel, 1);
	if g_currentMission.environment.lastRainScale <= 0.1 and g_currentMission.environment.timeSinceLastRain > 30 then
		dens = dens1+dens2+dens3;
	end;
	if dens > 0 and self.lastSpeed*self.speedDisplayScale*3600 > 4 then
		if not self.wheelMode then
			for k=1, 4 do
				Utils.setEmittingState(self.twinWheelParticleSystems[k].particleSystems, self.wheels[k].hasGroundContact);
			end;
		else
			for i=1, table.getn(self.twinWheelParticleSystems) do
				Utils.setEmittingState(self.twinWheelParticleSystems[i].particleSystems, false);
			end;
		end;
		for k=1, 4 do
			Utils.setEmittingState(self.wheelParticleSystems[k].particleSystems, self.wheels[k].hasGroundContact);
		end;
	else
		for i=1, table.getn(self.wheelParticleSystems) do
			Utils.setEmittingState(self.wheelParticleSystems[i].particleSystems, false);
		end;
		for i=1, table.getn(self.twinWheelParticleSystems) do
			Utils.setEmittingState(self.twinWheelParticleSystems[i].particleSystems, false);
		end;
	end;
	for i=1, table.getn(self.attacherJoints) do
		if self.attacherJoints[i].rotationNode ~= nil then
			local attacherJointNode = self.attacherJoints[i].rotationNode;
			local x, y, z = getRotation(attacherJointNode);
			local newX = x+Utils.degToRad(23.5);
			setRotation(self.backCoupling.topArmNode, newX, y, z);
			setRotation(self.backCoupling.rotationNode, newX, y, z);
			local x1, y1, z1 = getRotation(self.backCoupling.topArmNode);
			local newX1 = x1/-2;
			setRotation(self.backCoupling.rotationNode2, newX1, y1, z1);
		end;
	end;
end;

function ChallengerHeckhydraulik:draw()
	if self.helpPanelActive then
		self.helpPanelOverlay:render();
		renderText(self.helpPanelTextPosX, self.helpPanelTextPosY-0.351, 0.025, string.format("Taste %s: %s", InputBinding.getButtonKeyName(InputBinding.HELPPANELCAT), g_i18n:getText("CatHelpPanelOn_2")));
		if self.lightCount == 0 then
			renderText(self.helpPanelTextPosX, self.helpPanelTextPosY-0.159, 0.024, string.format("Taste %s: %s", InputBinding.getButtonKeyName(InputBinding.TOGGLE_LIGHTS), g_i18n:getText("CatWorklightOn_2")));
		elseif self.lightCount < 6 then
			renderText(self.helpPanelTextPosX, self.helpPanelTextPosY-0.159, 0.024, string.format("Taste %s: %s", InputBinding.getButtonKeyName(InputBinding.TOGGLE_LIGHTS), g_i18n:getText("CatWorklightNext_2")));
		else
			renderText(self.helpPanelTextPosX, self.helpPanelTextPosY-0.159, 0.024, string.format("Taste %s: %s", InputBinding.getButtonKeyName(InputBinding.TOGGLE_LIGHTS), g_i18n:getText("CatWorklightOff_2")));
		end;
		if self.catHandbrake then
			setTextColor(1.0, 0, 0, 1.0);
			renderText(self.helpPanelTextPosX, self.helpPanelTextPosY-0.183, 0.024, string.format("Taste %s: %s", InputBinding.getButtonKeyName(InputBinding.CATHANDBRAKE), g_i18n:getText("CatHandbrakeOff_2")));
			setTextColor(1.0, 1.0, 1.0, 1.0);
		else
			renderText(self.helpPanelTextPosX, self.helpPanelTextPosY-0.183, 0.024, string.format("Taste %s: %s", InputBinding.getButtonKeyName(InputBinding.CATHANDBRAKE), g_i18n:getText("CatHandbrakeOn_2")));
		end;
		renderText(self.helpPanelTextPosX, self.helpPanelTextPosY-0.207, 0.024, string.format("Oildruck: %.1f bar / Bremsdruck %.1f bar", self.oilPressure, self.brakePressure));
		if self.wheelMode then
			renderText(self.helpPanelTextPosX, self.helpPanelTextPosY-0.231, 0.024, string.format("Taste %s: %s", InputBinding.getButtonKeyName(InputBinding.CATWHEELMODE), g_i18n:getText("CatAllWheel_2")));
		else
			renderText(self.helpPanelTextPosX, self.helpPanelTextPosY-0.231, 0.024, string.format("Taste %s: %s", InputBinding.getButtonKeyName(InputBinding.CATWHEELMODE), g_i18n:getText("CatFourWheel_2")));
		end;
		renderText(self.helpPanelTextPosX, self.helpPanelTextPosY-0.255, 0.024, string.format("Taste %s Frontgewicht: %d kg", InputBinding.getButtonKeyName(InputBinding.CATWEIGHT_ACTIVE), self.currentWeight));
		if self.rearAttacher then
			renderText(self.helpPanelTextPosX, self.helpPanelTextPosY-0.279, 0.024, string.format("Taste %s: %s", InputBinding.getButtonKeyName(InputBinding.REARATTACHER), g_i18n:getText("REARATTACHER2_2")));
		else
			renderText(self.helpPanelTextPosX, self.helpPanelTextPosY-0.279, 0.024, string.format("Taste %s: %s", InputBinding.getButtonKeyName(InputBinding.REARATTACHER), g_i18n:getText("REARATTACHER1_2")));
		end;
		if not self.isMotorStarted and not self.automaticStart then	
			renderText(self.helpPanelTextPosX, self.helpPanelTextPosY-0.303, 0.024, string.format("Taste %s: %s", InputBinding.getButtonKeyName(InputBinding.CATIGNITION), g_i18n:getText("CatStart_2")));
		else
			renderText(self.helpPanelTextPosX, self.helpPanelTextPosY-0.303, 0.024, string.format("Taste %s: %s", InputBinding.getButtonKeyName(InputBinding.CATIGNITION), g_i18n:getText("CatStop_2")));
		end;
		if self.isMotorStarted then	
			if self.reverse then
				renderText(self.helpPanelTextPosX, self.helpPanelTextPosY-0.327, 0.024, string.format("Taste %s: %s", InputBinding.getButtonKeyName(InputBinding.CAT_REVERSE), g_i18n:getText("CatShuttleReverser1_2")));
			else
				renderText(self.helpPanelTextPosX, self.helpPanelTextPosY-0.327, 0.024, string.format("Taste %s: %s", InputBinding.getButtonKeyName(InputBinding.CAT_REVERSE), g_i18n:getText("CatShuttleReverser2_2")));
			end;
		end;
	else
		if not self.isMotorStarted then	
			g_currentMission:addHelpButtonText(g_i18n:getText("CatStart_2"), InputBinding.CATIGNITION);
		end;
		g_currentMission:addHelpButtonText(g_i18n:getText("CatHelpPanelOff_2"), InputBinding.HELPPANELCAT);
	end;
end;

function ChallengerHeckhydraulik:onLeave()
	setVisibility(self.worklightBack, false);
	setVisibility(self.worklightBack2, false);
	setVisibility(self.worklightFront, false);
	setVisibility(self.farLight, false);
	setVisibility(self.farLight2, false);
	setVisibility(self.farLight3, false);
	setVisibility(self.farLight4, false);
	self.terminalCode = 0;
	setVisibility(self.terminalPic, false);
	setVisibility(self.brakeLight, false);
	for k,implement in pairs(self.attachedImplements) do
		if implement.object.releaseBrake then
			implement.object:releaseBrake();
		end;
    end;
end;

function ChallengerHeckhydraulik:onEnter()
	self.full = false;
end;

function ChallengerHeckhydraulik:brake()
    setVisibility(self.brakeLight, true);
    for k,implement in pairs(self.attachedImplements) do
		if implement.object.brake then
			implement.object:brake();
		end;
	end;
end;

function ChallengerHeckhydraulik:releaseBrake()
    setVisibility(self.brakeLight, false);
	for k,implement in pairs(self.attachedImplements) do
		if implement.object.releaseBrake then
			implement.object:releaseBrake();
		end;
    end;
end;

function ChallengerHeckhydraulik:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)	
	if not resetVehicles then
		local brakePressure = Utils.getNoNil(getXMLFloat(xmlFile, key .. "#brakePressure"), self.brakePressure);
		self.brakePressure = brakePressure;
	end; 
    return BaseMission.VEHICLE_LOAD_OK;
end;

function ChallengerHeckhydraulik:getSaveAttributesAndNodes(nodeIdent)
	local attributes = 'brakePressure="' .. tostring(self.brakePressure) ..'"';
	return attributes, nil;
end;

function ChallengerHeckhydraulik:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;
